websoft9/docker/proxy/s6/w9init/setuser.sh

61 lines
1.9 KiB
Bash
Raw Normal View History

2023-09-22 15:15:43 +08:00
#!/bin/bash
2023-09-23 14:43:41 +08:00
set +e
2023-09-22 15:15:43 +08:00
username="help@websoft9.com"
password=$(openssl rand -base64 16 | tr -d '/+' | cut -c1-16)
token=""
cred_path="/data/credential"
2023-10-24 09:05:28 +08:00
max_attempts=10
2023-09-22 15:15:43 +08:00
echo "Start to change nginxproxymanage users"
2023-09-22 15:15:43 +08:00
if [ -e "$cred_path" ]; then
echo "File $cred_path exists. Exiting script."
2023-09-22 16:38:33 +08:00
exit 0
2023-09-22 15:15:43 +08:00
fi
echo "create diretory"
mkdir -p "$(dirname "$cred_path")"
sleep 10
2023-09-22 15:15:43 +08:00
while [ -z "$token" ]; do
sleep 5
login_data=$(curl -X POST -H "Content-Type: application/json" -d '{"identity":"admin@example.com","scope":"user", "secret":"changeme"}' http://localhost:81/api/tokens)
token=$(echo $login_data | jq -r '.token')
done
echo "Change username(email)"
2023-10-24 09:05:28 +08:00
for attempt in $(seq 1 $max_attempts); do
2023-09-23 11:29:08 +08:00
response=$(curl -X PUT -H "Content-Type: application/json" -H "Authorization: Bearer $token" -d '{"email": "'$username'", "nickname": "admin", "is_disabled": false, "roles": ["admin"]}' http://localhost:81/api/users/1)
if [ $? -eq 0 ]; then
2023-10-23 16:13:35 +08:00
echo "Set username successful"
2023-09-23 11:29:08 +08:00
break
else
2023-10-23 16:13:35 +08:00
echo "Set username failed, retrying..."
2023-09-23 11:29:08 +08:00
sleep 5
2023-10-24 09:05:28 +08:00
if [ $attempt -eq $max_attempts ]; then
echo "Failed to set username after $max_attempts attempts. Exiting."
exit 1
fi
2023-09-23 11:29:08 +08:00
fi
done
2023-09-22 15:15:43 +08:00
echo "Update password"
2023-10-24 09:05:28 +08:00
for attempt in $(seq 1 $max_attempts); do
2023-09-23 11:29:08 +08:00
response=$(curl -X PUT -H "Content-Type: application/json" -H "Authorization: Bearer $token" -d '{"type":"password","current":"changeme","secret":"'$password'"}' http://localhost:81/api/users/1/auth)
if [ $? -eq 0 ]; then
2023-10-23 16:13:35 +08:00
echo "Set password successful"
echo "Save to credential"
json="{\"username\":\"$username\",\"password\":\"$password\"}"
echo "$json" > "$cred_path"
2023-09-23 11:29:08 +08:00
break
else
2023-10-23 16:13:35 +08:00
echo "Set password failed, retrying..."
2023-09-23 11:29:08 +08:00
sleep 5
2023-10-24 09:05:28 +08:00
if [ $attempt -eq $max_attempts ]; then
echo "Failed to set password after $max_attempts attempts. Exiting."
exit 1
fi
2023-09-23 11:29:08 +08:00
fi
done
2023-09-22 15:15:43 +08:00
2023-09-26 16:06:28 +08:00
set -e